﻿namespace BPA.Component.ClickHouseClient.Models
{
    /// <summary>
    /// 批量插入 源-目标 字段模型
    /// </summary>
    public class BulkCopySourceTargetColumnInfo
    {
        /// <summary>
        /// 源字段名称
        /// </summary>
        public string SourceColum { set; get; }

        /// <summary>
        /// 目标字段名称
        /// </summary>
        public string TargetColum { set; get; }

        /// <summary>
        /// 默认值
        /// </summary>
        public object DefaultValue { set; get; }

        /// <summary>
        /// 处理字段值的 Func
        /// </summary>
        public Func<object, object> ProccessValue { set; get; }
    }
}