﻿using BPA.Component.ClickHouseClient;

namespace BPA.Component.ClickHouseClientTester.Model
{
    public class TestClickHouseProvider : ClickHouseProvider
    {
        /// <summary>
        /// TestClickHouseProvider
        /// </summary>
        /// <param name="configs"></param>
        public TestClickHouseProvider(List<ClickHouseConfig> configs) : base(configs)
        {

        }


        /// <summary>
        /// 根据企业Id获取数据库别名,子类必须实现
        /// </summary>
        /// <param name="corpId"></param>
        /// <returns></returns>
        protected override string GetConnectionAliasByCropId(long corpId)
        {
            return "crm-test-01";
        }
    }
}
