﻿namespace BPA.Component.DTOCommon.BaseDTOs
{
    /// <summary>
    /// DefaultLazy
    /// </summary>
    /// <typeparam name="T"></typeparam>
    public class DefaultLazy<T> : Lazy<T>
    {
        /// <summary>
        /// DefaultLazy
        /// </summary>
        /// <param name="serviceProvider"></param>
        public DefaultLazy(IServiceProvider serviceProvider)
            : base(() => (T) (serviceProvider.GetService(typeof(T)) ?? throw new InvalidOperationException()))
        {
        }
    }
}