﻿using System.Collections.Generic;
using System.Threading.Tasks;
using BPA.Component.DbClient.RepositoryModel;
using BPA.Component.DbClientTester.Entities;

namespace BPA.Component.DbClientTester.Repositorys;

/// <summary>
/// 仓储接口
/// </summary>
public interface IUserRepository : IDbRepository<BPA_Users>
{
    /// <summary>
    /// 查询
    /// </summary>
    /// <param name="id"></param>
    /// <param name="name"></param>
    /// <returns></returns>
    public Task<List<BPA_Users>> Query(string id, string name);
}