﻿namespace BPA.Component.Extensions
{
    /// <summary>
    /// IEnumerable 扩展
    /// </summary>
    public static class IEnumerableExtension
    {
        /// <summary>
        /// Each
        /// </summary>
        /// <typeparam name="TItem"></typeparam>
        /// <param name="source"></param> 
        /// <param name="func"></param>
        public static void Each<TItem>(this IEnumerable<TItem> source, Action<TItem> func)
        {
            foreach (var item in source)
                func(item);
        }
    }
}