﻿using BPA.Component.RabbitMQClient.Base;

namespace BPA.Component.RabbitMQClient.Result
{
    /// <summary>
    /// RegisterResult
    /// </summary>
    public class RegisterProducerResult<TMsgBody, TProducer> : IRegisterProducerResult
    {

        /// <summary>
        /// producer
        /// </summary>
        private readonly BaseProducer<TMsgBody, TProducer> producer;

        /// <summary>
        /// RegisterResult
        /// </summary>
        /// <param name="producer"></param> 
        public RegisterProducerResult(BaseProducer<TMsgBody, TProducer> producer)
        {
            this.producer = producer;
        }

        /// <summary>
        /// Dispose
        /// </summary>
        public void Dispose()
        {
        }
    }
}
