﻿using DotNetCore.CAP;
using DotNetCore.CAP.Internal;
using DotNetCore.CAP.Processor;
using DotNetCore.CAP.Serialization;
using DotNetCore.CAP.Transport;
using Microsoft.Extensions.DependencyInjection.Extensions;

namespace BPA.Component.WebApiExtensions.Extensions;

public static class CAPExtension
{
    public static CapBuilder AddBpaCap(this IServiceCollection services, Func<IServiceProvider> sp)
    {
        if (sp == null)
            throw new ArgumentNullException(nameof(sp));

        // services.AddSingleton(_ => services);
        // services.TryAddSingleton<CapMarkerService>();
        //
        // services.TryAddSingleton<ICapPublisher, CapPublisher>();
        //
        // services.TryAddSingleton<IConsumerServiceSelector, ConsumerServiceSelector>();
        // services.TryAddSingleton<ISubscribeInvoker, SubscribeInvoker>();
        // services.TryAddSingleton<MethodMatcherCache>();
        //
        // services.TryAddSingleton<IConsumerRegister, ConsumerRegister>();
        //
        // //Processors
        // services.TryAddEnumerable(ServiceDescriptor.Singleton<IProcessingServer, IDispatcher>(sp => sp.GetRequiredService<IDispatcher>()));
        // services.TryAddEnumerable(ServiceDescriptor.Singleton<IProcessingServer, IConsumerRegister>(sp => sp.GetRequiredService<IConsumerRegister>()));
        // services.TryAddEnumerable(ServiceDescriptor.Singleton<IProcessingServer, CapProcessingServer>());
        //
        // //Queue's message processor
        // services.TryAddSingleton<MessageNeedToRetryProcessor>();
        // services.TryAddSingleton<TransportCheckProcessor>();
        // services.TryAddSingleton<CollectorProcessor>();
        //
        // //Sender
        // services.TryAddSingleton<IMessageSender, MessageSender>();
        //
        // services.TryAddSingleton<ISerializer, JsonUtf8Serializer>();
        //
        // // Warning: IPublishMessageSender need to inject at extension project. 
        // services.TryAddSingleton<ISubscribeDispatcher, SubscribeDispatcher>();
        //
        // //Options and extension service
        // var options = new CapOptions();
        // setupAction(options);
        //
        // //Executors
        // if (options.UseDispatchingPerGroup)
        // {
        //     services.TryAddSingleton<IDispatcher, DispatcherPerGroup>();
        // }
        // else
        // {
        //     services.TryAddSingleton<IDispatcher, Dispatcher>();
        // }
        //
        // foreach (var serviceExtension in options.Extensions)
        // {
        //     serviceExtension.AddServices(services);
        // }
        //
        // services.Configure(setupAction);
        //
        // //Startup and Hosted 
        // services.AddSingleton<Bootstrapper>();
        // services.AddHostedService(sp => sp.GetRequiredService<Bootstrapper>());
        // services.AddSingleton<IBootstrapper>(sp => sp.GetRequiredService<Bootstrapper>());

        return new CapBuilder(services);
    }
}