﻿namespace BPA.Component.ClickHouseClient
{
    /// <summary>
    /// ClickHouse 配置
    /// </summary>
    public class ClickHouseConfig
    {
        /// <summary>
        /// 别名,同一种的业务数据库的可以有多个，但是每个的别名都不能相同
        /// </summary>
        public string Alias { set; get; }

        /// <summary>
        /// 连接字符串 
        /// 示例:
        /// Compression=true;UseSession=false;Timeout=600000;Database=test;Host=192.168.0.150;Port=8123;Username=default;Password=123456;Protocol=http
        /// </summary>
        public string ConnectionString { set; get; }
    }
}