﻿// using System.Diagnostics;
// using BPA.Component.ClickHouseClient;
// using BPA.Component.ClickHouseClientTester.Model;
// using ClickHouse.Client.Copy;
// using ClickHouse.Client.Utility;
// using Microsoft.VisualStudio.TestTools.UnitTesting;
//
// namespace BPA.Component.ClickHouseClientTester
// {
//
//     /// <summary>
//     ///  
//     /// </summary> 
//     [TestClass()]
//     public class ClickHouseProviderTests
//     {
//         private readonly TestClickHouseProvider provider;
//
//         private readonly long corpId = 10000;
//         public ClickHouseProviderTests()
//         {
//             var clickHouseConStr = "Compression=true;UseSession=true;Timeout=60;" +
//                                                              "Database=test;Host=192.168.0.150;Port=8123;Username=default;Password=123456;Protocol=http";
//             var config = new ClickHouseConfig { Alias = "crm-test-01", ConnectionString = clickHouseConStr };
//             provider = new TestClickHouseProvider(new List<ClickHouseConfig> { config });
//         }
//
//         [TestMethod()]
//         public void Test_Insert()
//         {
//             var bulkRows = new List<object[]>();
//             for (var i = 0; i < 10000; i++)
//             {
//                 var row = new CorpInfoSynLocal
//                 {
//                     Id = 1,
//                     Name = "t1",
//                     No = "n1",
//                     Phones = new string[0],
//                     CorpId = corpId,
//                     CreateDate = DateTime.Now,
//                     EnumEmployee = EnumEmployeeStatusType.Normal,
//                     IsTTLDelete = false,
//                     TTLDate = DateTime.MaxValue,
//                     UpdateDate = DateTime.Now
//                 };
//                 bulkRows.Add(new object[] {
//                     row.Id, row.CorpId,
//                     row.No, row.Name, row.Phones,row.CreateDate, row.EnumEmployee,
//                     row.IsTTLDelete, row.TTLDate, row.UpdateDate });
//             }
//             var columns = "Id, CorpId, No, Name, Phones, CreateDate, EnumEmployee,IsTTLDelete,TTLDate,UpdateDate".Split(",");
//             Stopwatch stopwatch = new Stopwatch();
//             stopwatch.Start();
//             using var bulkCopy = new ClickHouseBulkCopy(provider.GetConnection(corpId))
//             {
//                 DestinationTableName = "test.CorpInfoSynLocal",
//                 BatchSize = bulkRows.Count,
//             };
//             bulkCopy.WriteToServerAsync(bulkRows, columns).GetAwaiter().GetResult();
//             stopwatch.Stop();
//             Console.WriteLine(stopwatch.ElapsedMilliseconds);
//         }
//
//         [TestMethod()]
//         public void Test_Delete()
//         {
//             var bulkRows = new List<object[]>();
//             for (var i = 0; i < 1; i++)
//             {
//                 var row = new CorpInfoSynLocal
//                 {
//                     Id = 1,
//                     Name = "t1",
//                     No = "n1",
//                     Phones = new string[0],
//                     CorpId = corpId,
//                     CreateDate = DateTime.Now,
//                     EnumEmployee = EnumEmployeeStatusType.Normal,
//                     IsTTLDelete = true,
//                     TTLDate = DateTime.Now.AddSeconds(3600),
//                     UpdateDate = DateTime.Now
//                 };
//                 bulkRows.Add(new object[] { row.Id, row.CorpId, row.IsTTLDelete, row.TTLDate, row.UpdateDate });
//             }
//             var columns = "Id, CorpId, IsTTLDelete,TTLDate,UpdateDate".Split(",");
//             Stopwatch stopwatch = new Stopwatch();
//             stopwatch.Start();
//             using var bulkCopy = new ClickHouseBulkCopy(provider.GetConnection(corpId))
//             {
//                 DestinationTableName = "test.CorpInfoSynLocal",
//                 BatchSize = bulkRows.Count,
//             };
//             bulkCopy.WriteToServerAsync(bulkRows, columns).GetAwaiter().GetResult();
//             stopwatch.Stop();
//             Console.WriteLine(stopwatch.ElapsedMilliseconds);
//         }
//
//
//         [TestMethod()]
//         public void Test_Queue2()
//         {
//             var sql = "SELECT   *  FROM  test.CorpInfoSynLocal    FINAL WHERE Id >{Id:Int64}";
//             var cmd = provider.GetConnection(corpId).CreateCommand();
//             //   cmd.AddParameter("Id", 0L);
//             cmd.CommandText = sql;
//             cmd.AddParameter("Id", "Int64", 0);
//             var oldRows = new Dictionary<long, Dictionary<string, object>>();
//             long idx = 0;
//             using (var reader = cmd.ExecuteReader())
//             {
//                 while (reader.Read())
//                 {
//                     var row = new Dictionary<string, object>();
//                     for (var i = 0; i < reader.FieldCount; i++)
//                     {
//                         var value = reader[i];
//                         var key = reader.GetName(i);
//                         row.Add(key, value);
//                     }
//                     idx++;
//                     oldRows.Add(idx, row);
//                 }
//             }
//         }
//
//
//
//         [TestMethod()]
//         public void Test_Queue3()
//         {
//             var sql = @"
// SELECT 
// Id, CorpId, `No`, Name, Phones, CreateDate, 
// EnumEmployee, IsLike, IsTTLDelete, 
// TTLDate, UpdateDate
// FROM test.CorpInfoSynLocal
// FINAL WHERE Id >{Id:Int64}";
//             var connection = provider.GetConnection(corpId);
//             var result = connection.Query<CorpInfoSynLocal>(sql, new Dictionary<string, object> { { "Id", 0 } });
//         }
//
//
//
// //         /// <summary>
// //         /// with(select [id1,id2]) as Ids  select Id,* from table where  has(Ids,Id)
// //         /// </summary>
// //         [TestMethod()]
// //         public void Test_Queue4()
// //         {
// //             Stopwatch stopwatch = new Stopwatch();
// //             stopwatch.Start();
// //             var connection = provider.GetConnection(corpId);
// //             var ids = Enumerable.Repeat(BPAUniqueIdBulder.NextLong(), 12000).ToList();
// //             ids.Add(240777732430463137);
// //             ids.Add(240777781797421056);
// //             ids.Add(240777781797421057);
// //             var sql = @$"
// // WITH(
// //   SELECT [{string.Join(",", ids)}]
// // )AS ids
// // SELECT 
// // Id, CorpId, `No`, Name, Phones, CreateDate, EnumEmployee, IsLike, IsTTLDelete, TTLDate, UpdateDate
// // FROM test.CorpInfoSynLocal
// // FINAL WHERE has( ids,Id ) ";
// //      
// //    
// //
// //             var result = connection.Query<CorpInfoSynLocal>(sql, new Dictionary<string, object> { { "Id", 0 } });
// //             stopwatch.Stop();
// //             Console.WriteLine(stopwatch.ElapsedMilliseconds);
// //         }
//
//
//
//         /// <summary>
//         ///  临时表
//         /// </summary>
//         [TestMethod()]
//         public void Test_Queue5()
//         {
//             Stopwatch stopwatch = new Stopwatch();
//             stopwatch.Start();
//             var connection = provider.GetConnection(corpId);
//             var temporarySpl = @"CREATE TEMPORARY TABLE IF NOT EXISTS TempId (Id Int64)";
//             //创建临时表
//             connection.ExecuteStatementAsync(temporarySpl);
//             var ids = Enumerable.Repeat(BPAUniqueIdBulder.NextLong(), 12000).ToList();     
//             ids.Add(240777732430463137);
//             ids.Add(240777781797421056);
//             ids.Add(240777781797421057);
//             var pids = new List<object[]>();
//             ids.Each(item => pids.Add(new object[] { item }));     
//             //将数据插入临时表
//             connection.BulkCopy("TempId", new string[] { "Id" }, pids);      
//             //查询临时表
//             var tempIds = connection.Query<long>("select Id from TempId");
//             // 其他表 in 临时表   
//             var sqlIn = @$" 
// SELECT 
// Id, CorpId, `No`, Name, Phones, CreateDate, EnumEmployee, IsLike, IsTTLDelete, TTLDate, UpdateDate
// FROM test.CorpInfoSynLocal
// FINAL WHERE Id in (select Id from TempId)";
//             var resultIn = connection.Query<CorpInfoSynLocal>(sqlIn);
//             stopwatch.Stop();
//             Console.WriteLine(stopwatch.ElapsedMilliseconds);
//
//             // 其他表 in 临时表   
//             var sqlJoin = @$" 
// Select T1.* FROM (SELECT 
// Id, CorpId, `No`, Name, Phones, CreateDate, EnumEmployee, IsLike, IsTTLDelete, TTLDate, UpdateDate
// FROM test.CorpInfoSynLocal FINAL) AS T1
// INNER JOIN TempId AS T2 On T1.Id=T2.Id  
// ";
//             var resultJoin = connection.Query<CorpInfoSynLocal>(sqlJoin);
//
//         }
//
//
//     }
// }