﻿namespace BPA.Component.DTOCommon.BaseDTOs
{
    /// <summary>
    /// 自定义表单存储数据DTO  (主表单非固定字段+非特殊子表单数据)
    /// </summary>
    public class BaseCustomFormDataWithSubDTO : BaseCustomFormDataDTO
    {
        /// <summary>
        /// 多子表表单存储数据(非特殊子表单数据)
        /// key: 子表名称  value: 子表多行数据行  ，子表单行数据结构和 主表存储数据是一样的，都是key:value格式
        /// </summary>
        public Dictionary<string, List<Dictionary<string, object>>> SubFormData { get; set; }
    }
}