﻿namespace BPA.Component.DTOCommon.BaseDTOs
{
    /// <summary>
    /// 基础的分页查询
    /// </summary>
    public class BasePageInfo
    {
        private int pageSize = 30;

        /// <summary>
        /// 每页条数 默认30
        /// </summary> 
        public int PageSize
        {
            set { pageSize = value <= 0 ? 30 : value; }
            get => pageSize;
        }

        private int pageIndex = 1;

        /// <summary>
        /// 页码 默认1
        /// </summary>
        public int PageIndex
        {
            set { pageIndex = value <= 0 ? 1 : value; }
            get => pageIndex;
        }
    }
}