﻿namespace BPA.Component.DbClient
{
    /// <summary>
    /// 多数据库情况下数据库配置
    /// </summary>
    public class DbConfig
    {
        /// <summary>
        /// 别名,同一种的业务数据库的可以有多个，但是每个的别名都不能相同
        /// </summary>
        public string Alias { set; get; } = "dbo";

        /// <summary>
        /// 主库连接字符串
        /// </summary>
        public string MasterDbConnectionString { set; get; }

        /// <summary>
        /// 从库连接字符串,可以是多个
        /// </summary>
        public string[] SlaveDbConnectionConfigs { set; get; }
    }
}