﻿using BPA.Component.DbClient;
using BPA.Component.DbClient.RepositoryModel;
using Microsoft.Extensions.Logging;
using SqlSugar;

namespace BPA.Component.DbClientTester
{
    /// <summary>
    /// TestDbClient
    /// </summary>
    public class TestDbClient : BaseDbClient<TestDbClient>
    {
        /// <summary>
        /// TestDbClient
        /// </summary>
        /// <param name="config"></param>
        /// <param name="logger"></param>
        public TestDbClient(TestConfig config, ILogger<TestDbClient> logger)
            : base(BuildConnectionConfig(config.MySqlDb, DbType.SqlServer),
                true,
                logger)
        {
        }
    }
}