﻿namespace BPA.Component.Extensions
{
    /// <summary>
    /// MathExtensions
    /// </summary>
    public static class MathExtensions
    {
        /// <summary>
        /// 取整保留两位小数
        /// </summary>
        /// <param name="v"></param>
        /// <returns></returns>
        public static decimal ToCeiling(this decimal v)
        {
            var isNegative = false;
            if (v < 0)
            {
                isNegative = true;
                v = -v;
            }
            var value = 1;
            for (var i = 1; i <= 2; i++)
            {
                value *= 10;
            }
            var Int = Math.Ceiling(v * value);
            v = Int / value;
            if (isNegative)
            {
                v = -v;
            }
            return v;
        }
    }
}

