﻿using BPA.Component.ApolloClient;
using BPA.Component.MongoClient;
using Com.Ctrip.Framework.Apollo;
using Microsoft.Extensions.Configuration;

namespace BPA.Component.DbClientTester;

/// <summary>
/// test项目配置
/// </summary>
public class TestConfig : ApolloBPAConfig<TestConfig>
{
    [AutoWrite]
    public MongoConfig MongoDbForWebApi1Db { get; set; }

    public TestConfig(ApolloConfigurationManager apolloConfigurationManager, IConfiguration configuration) : base(apolloConfigurationManager, configuration)
    {
        
    }
}