﻿namespace BPA.Component.RabbitMQClient.Enums
{
    /// <summary>
    /// 消息交付模式 ;Non-persistent (1) or persistent (2).
    /// </summary>
    public enum DeliveryModeType : byte
    {
        /// <summary>
        /// 不持久化消息
        /// </summary>
        NonPersistent = 1,

        /// <summary>
        /// 持久化消息
        /// </summary>
        Persistent = 2,
    }
}
