﻿using BPA.Component.ApolloClient;
using BPA.Component.RabbitMQClient.Connection;
using Com.Ctrip.Framework.Apollo;
using Microsoft.Extensions.Configuration;

namespace BPA.Component.RabbitMQClientTester.Modesl
{
    /// <summary>
    /// test项目配置
    /// </summary>
    public class TestConfig : ApolloBPAConfig<TestConfig>
    {
        #region 当前应用配置

        /// <summary>
        /// RabbitMQ配置
        /// </summary>
        [AutoWrite]
        public RabbitMqConnectionConfig RabbitMqConfig { get; set; }
        
        #endregion

        public TestConfig(ApolloConfigurationManager apolloConfigurationManager, IConfiguration configuration) : base(apolloConfigurationManager, configuration)
        {
        }
    }
}