pwd
current_dir=$(pwd)
nuget_key="55e7b6bd-6eeb-3ad5-8d4c-24b7d08d01f7"
nuget_source="http://nuget.BPA.com.cn/repository/nuget-hosted/"

#pakcage version , keep pace with nuspec
package_version="0.0.1"
#nupkg package name
nupkg_pakcage_name="BPA.Component.ApmClient.${package_version}.nupkg"
#csproj path
csproj_path="../BPA.Component.ApmClient/BPA.Component.ApmClient.csproj"
#nuspec path
nuspec_path="BPA.Component.ApmClient.nuspec"
#nuspec path , relative csproj path
nuspec_path_relative_csproj="../pack/BPA.Component.ApmClient.nuspec"

rm -f nupkg_pakcage_name
cd ..
cd ..
git pull
cd ${current_dir}

#replace package version
sed -i '5d' ${nuspec_path}
version_node="<version>${package_version}</version>"
sed -i "5i ${version_node}" ${nuspec_path}

echo pack ${nupkg_pakcage_name}
dotnet pack ${csproj_path} -p:NuspecFile=${nuspec_path_relative_csproj} -c Release --output ../pack -v m

#check nuget file is exist
echo
if [ ! -f "${nupkg_pakcage_name}" ]; then
  echo "pack ${nupkg_pakcage_name} is error"
  # shellcheck disable=SC2242
  exit -1
fi

#push nupkg
echo push ${nupkg_pakcage_name}
dotnet nuget push ${nupkg_pakcage_name} -k ${nuget_key} -s ${nuget_source}
